{program Discover;}
{$IFDEF WINDOWS}
uses synaser,synautil,synaip,blcksock,dos,crt;
var
ser:TBlockSerial;
TheComPort : string;
IPAddr : string;
Socket : TUDPBlockSocket;
{$ELSE}
uses dos,crt;
var TheComPort : word;
{$ENDIF}


const
DataStride = 4;
TooManyRecords = 10000;

Datapad = 0;
Databits = 1;
Dataunsigned = 2;
Datasigned = 3;
DataNonVolUnsigned =4;
DataNonVolSigned = 5;
DataStream = 6;
DataBoolean = 7;
DataCount = 8;

HWMode = 0;
SWMode = 1;

DataOutput	= $80;
DataInput	= $00;
DataBiDir	= $40;
DataDirectionMask= DataOutput or DataBiDir;
ArraySizeMask = not(DataDirectionMask);

const
RecordSize = 100;
PDRecordType = $A0;
MDRecordType = $B0;

var
BasePort : word;
Parameter : longint;
Retcode : integer;
UseHex : boolean;
DoRepeat : boolean;
temp : word;
GlobalTOCEntry,ProcessTOCEntry : word;
GlobalTOC,ProcessTOC : word;
ParmDataLo,ParmDataHi : comp;
OurPtr : word;
RecordPointer : integer;
WhichSWMode : longint;
RecordType : byte;

{$I SELECTC}
{$I SELECTIO}
{I SELECTP}
{$I SELECTPR}
{$I INTERFCE}

type
PDRecord =
record
  RecordType : byte;
  DataLength : byte;
  DataType   : byte;
  DataDirection : byte;
  ParamMin : single;
  ParamMax : single;
  ParamAddress : word;
  UnitString : string[80];
  NameString : string[80];
end;

MDRecord =
record
  RecordType : byte;
  ModeIndex : byte;
  ModeType   : byte;
  ModeUnused   : byte;
  ModeNameString : string[80];
end;

var
count : longint;
ByteData : byte;
Data : longint;
Parmtype : byte;
Errors : byte;
Status_State : byte;
Status : byte;
State : byte;
AWord : word;
ASingle : single;
Datatype : byte;
ArraySize : byte;
parmaddress : word;
index : integer;

PDRecords : array[1 .. RecordSize] of PDRecord;
MDRecords : array[1 .. RecordSize] of MDRecord;

procedure FixCRT;
{ Fix re-direction when using CRT unit }
begin
  assign(input,'');
  reset(input);
  assign(output,'');
  rewrite(output);
end;

procedure Error(err : integer);
begin
  writeln(errorrecord[err].errstr);
  halt(2);
end;

procedure Barfout(es:string);
begin
  writeln;
  writeln(es);
  halt(2);
end;

function GetSingle(p : word) : single;
{$IFDEF WINDOWS}
var
l : longint;
s : single;
begin
    l := ReadLong(p);
    move(l,s,4);
    GetSingle := s;
end;
{$ELSE}
{this ptr access nonsense is to escape Pascals typing}
var
ps : ^single;
segment,offset : word;
l : longint;
s : single;
begin
    l := ReadLong(p);
    segment := seg(l);
    offset := ofs(l);
    ps := ptr(segment,offset);
    GetSingle := ps^;
end;
{$ENDIF}


function GetNullTermString(var ptr : word) : string;
var ourstring : string;
begin
  ourstring := '';
  while ReadByte(ptr) <> 0 do
  begin
    ourstring := ourstring + char(ReadByte(ptr));
    ptr := ptr + 1;
  end;
  ptr := ptr + 1; { skip null }
  GetNullTermString := ourstring;
end;

procedure GetMDRecord(ptr : word);
var index : word;
begin
  index := ptr;
  with MDRecords[RecordPointer] do
  begin
    RecordType := ReadByte(index+0);
    ModeIndex := ReadByte(index+1);
    ModeType := ReadByte(index+2);
    ModeUnused  := ReadByte(index+3);
    index := index + 4;
    ModeNameString := GetNullTermString(index);
  end;
end;

procedure GetPDRecord(ptr : word);
var index : word;
begin
  index := ptr;
  with PDRecords[RecordPointer] do
  begin
    RecordType := ReadByte(index+0);
    DataLength := ReadByte(index+1);
    DataType := ReadByte(index+2);
    ArraySize := ReadByte(index+3) and ArraySizeMask;
    DataDirection  := ReadByte(index+3) and DataDirectionMask;
    ParamMin := GetSingle(index+4);
    ParamMax := Getsingle(index+8);
    ParamAddress := ReadWord(index+12);
    index := index + 14;
    UnitString := GetNullTermString(index);
    NameString := GetNullTermString(index);
  end;
end;

procedure PrintMDRecord;
begin
  writeln('Mode Record ',RecordPointer);
  with MDRecords[RecordPointer] do
  begin
    writeln('ModeIndex ',ModeIndex);
    write('Mode ');
    case ModeType of
        HWMode:               writeln('HWMode ');
        SWMode:               writeln('SWMode ');
       else BarfOut('Bad Mode Type');
    end;
    writeln('ModeUnused ',ModeUnused);
    writeln('ModeName ',ModeNameString);
  end;
  writeln;
end;

procedure PrintPDRecord;
begin
  with PDRecords[RecordPointer] do
  begin
    writeln('DataLength ',DataLength,' bits');
    write('DataType ');
    case DataType of
      databits:             writeln('Bits ');
      dataunsigned:         writeln('Unsigned ');
      datasigned:           writeln('Signed ');
      dataNonVolUnSigned:   writeln('NonVolUnsigned ');
      dataNonVolSigned:     writeln('NonVolSigned ');
      datastream:           writeln('Stream ');
      dataPad:              writeln('Padding ');
      dataBoolean:          writeln('Boolean ');
      dataCount:            writeln('Count');
      else BarfOut('Bad Data Type');
    end;
    write('DataDirection ');
    case DataDirection of
      (DataOutput and DataDirectionMask) : writeln('Output ');
      (DataInput and DataDirectionMask):   writeln('Input ');
      (DataBiDir and DataDirectionMask):   writeln('BiDir ');
      else BarfOut('Bad Data Direction Type');
    end;
    writeln('ParamMin ',ParamMin:5:4);
    writeln('ParamMax ',ParamMax:5:4);
    writeln('ParamAddress ',ParamAddress);;
    writeln('UnitString  ',UnitString);
    writeln('NameString  ',NameString);
  end;
  writeln;
end;

procedure GetParameter;
begin
  val(ParamStr(1),Axis,retcode);
  if retcode <> 0 then Axis := 0;
  val(ParamStr(2),WhichSWMode,retcode);
  if retcode <> 0 then WhichSWMode := 0;
end;  { GetParameter }

begin
  FixCrt;
  Axis := 0;
  GetParameter;
  GetOurEnv;
  if not InitializeInterface(message) then bumout(message);
  AxisStop(Axis);
  write32(CSRPort+(Axis*DataStride),WhichSWMode shl 24);
  if not AxisStartSetup(Axis) then bumout('No one home');

  Data := Read32(InterfacePort1+(Axis*DataStride));
  write('Card Name ');
  write(char(LongIntByteRec(Data).Byte0));
  write(char(LongIntByteRec(Data).Byte1));
  write(char(LongIntByteRec(Data).Byte2));
  write(char(LongIntByteRec(Data).Byte3));
  writeln;

  write('Unit Number ');
  HexPrint(Read32(InterfacePort0+(Axis*DataStride)),8);
  writeln;

  Data := Read32(InterfacePort2+(Axis*DataStride));
  ProcessTOC := LongIntRec(Data).LowWord;
  GlobalTOC  := LongIntRec(Data).HighWord;

  if ProcessTOC <> 0 then
  begin
    writeln;
    writeln('**** Current mode/process descriptors for Software mode ',WhichSWMode,' ****');
    RecordPointer := 0;
    while readword(ProcessTOC) <> 0 do
    begin
      ProcessTOCEntry := readword(ProcessTOC);
      RecordType := readbyte(ProcessTOCEntry);
      if RecordType = MDRecordType then
      begin
        GetMDRecord(ProcessTOCEntry); PrintMDRecord;
      end;
      if RecordType = PDRecordType then
      begin
        GetPDRecord(ProcessTOCEntry);
        writeln('Process Data Record ',RecordPointer);
        PrintPDRecord;
      end;
      if (RecordType <> PDRecordType) and (RecordType <> MDRecordType) then
        begin
          Write('Unknown Record Type 0x');
          HexPrint(RecordType,2);
          barfout('');
      end;
      RecordPointer := RecordPointer + 1;
      ProcessTOC := ProcessTOC + 2;
      if RecordPointer > TooManyRecords then barfout('TooMany records');
   end;
   if GlobalTOC <> 0 then
   begin
     writeln('**** Global mode/process descriptors ****');
     RecordPointer := 0;
     while readword(GlobalTOC) <> 0 do
     begin
       GlobalTOCEntry := readword(GlobalTOC);
       RecordType := readbyte(GlobalTOCEntry);
       if RecordType = MDRecordType then
       begin
         GetMDRecord(GlobalTOCEntry); PrintMDRecord;
         RecordPointer := RecordPointer + 1;
         GlobalTOC := GlobalTOC + 2;
       end;
       if RecordType = PDRecordType then
       begin
         GetPDRecord(GlobalTOCEntry);
         writeln('Parameter Data Record ',RecordPointer);
         PrintPDRecord;
         RecordPointer := RecordPointer + 1;
         GlobalTOC := GlobalTOC + 2;
         if RecordPointer > TooManyRecords then barfout('TooMany records');
       end;
       if (RecordType <> PDRecordType) and (RecordType <> MDRecordType) then
       begin
         Write('Unknown Record Type 0x');
         HexPrint(RecordType,2);
         barfout('');
       end;
     end;
   end;
 end;
 halt(0);
end.

{ added escapes if too many records or record not found }
