program INFO;

{$IFDEF WINDOWS}
uses synaser,synautil,synaip,blcksock,dos,crt;
var
ser:TBlockSerial;
TheComPort : string;
IPAddr : string;
Socket : TUDPBlockSocket;
{$ELSE}
uses dos,crt;
var TheComPort : word;
{$ENDIF}

var
OurChannel : integer;
BasePort : word;
Parameter : longint;
Retcode : integer;
ParmLoc : integer;
ParmName : string;

measuredtime,txchars,rxchars : byte;
timeperchar : real;
ourbaudrate : longint;
STDOutput : file;
BaudrateDivisor : longint;

{$I SELECTC}
{$I SELECTIO}
{I SELECTPR}
{$I INTERFCE}
{I sslbppr}

const
NumberOfChannels = 8;
DataStride = 4; {bytes}
TimerDivLoc = 97;
LoopTimeLoc = 101;

var
FailedTransferCount : array[0..7] of longint;
count : longint;
Data : longint;
Errors : byte;
Command : word;
Wait : longint;
Clock : real;
TimerDiv : word;
TimerTime : real; { seconds}

procedure FixCRT;
{ Fix re-direction when using CRT unit }
begin
  assign(input,'');
  reset(input);
  assign(STDOutput,'');
  rewrite(STDOutput);
end;

procedure Error(err : integer);
begin
  writeln(errorrecord[err].errstr);
  halt(2);
end;

procedure ClearFailedTransferCount;
var index : integer;
begin
  for index := 0 to 7 do
  begin
    FailedTransferCount[index] := 0;
  end;
end;

procedure Barfout(es:string);
begin
  writeln;
  writeln(es);
  halt(2);
end;

procedure GetParameter;
begin
  OurChannel := 0;
  if ParamCount > 0 then val(ParamStr(1),OurChannel,retcode);
  if retcode <>0 then barfout('Invalid Channel');
end;  { GetParameter }

begin
  FixCrt;
  GetParameter;
  GetOurEnv;
  {Message := 'Setup Mode';}
  if not InitializeInterface(message) then bumout(Message);
  FixCrt;
  SSLBPChannelStride := ReadSSRam(SSLBPChannelStrideLoc);
  SSLBPChannelStart := ReadSSRam(SSLBPChannelStartLoc);
  { set the above to avoid using setup mode }
  writeln('SSLBPChannelStart = ',SSLBPChannelStart,' SSLBPChannelStride = ',SSLBPChannelStride);
  Write('SSLBP Major Revision = ',ReadSSRAM(SSLBPMajorRevisionLoc));
  writeln(' SSLBP Minor Revision = ',ReadSSRAM(SSLBPMinorRevisionLoc));
  Write('SSLBP Processor Type = $');
  HexPrint(ReadSSRAM(SSLBPProcessorType),2);
  writeln;

  Writeln('SSLBP Number Of Channels = ',ReadSSRAM(SSLBPNumberOfChannels));
  Clock := ReadSSRAMLong(SSLBPClock)/1E6;

  Writeln('SSLBP Clock = ',Clock:3:6,' MHz');

{ card data }
  write('Card Name = ',SSLBPReadCardName(OurChannel),' Channel = ',ourchannel);

{ channel data }
  ourbaudrate := SSLBPGetBaud(OurChannel);
  BaudRateDivisor := ReadSSRAMLong(SSLBPDividend);
  Writeln(' Baud Rate = ',ourbaudrate);

  timeperchar := 10e6/ourbaudrate;

  write('RecvBuffer = HEX');
  write(' ');
  hexprint(ReadChanSSRam(OurChannel,ChanRecvstringOffset+0),2);
  write(' ');
  hexprint(ReadChanSSRam(OurChannel,ChanRecvstringOffset+1),2);
  write(' ');
  hexprint(ReadChanSSRam(OurChannel,ChanRecvstringOffset+2),2);
  write(' ');
  hexprint(ReadChanSSRam(OurChannel,ChanRecvstringOffset+3),2);
  write(' ');
  hexprint(ReadChanSSRam(OurChannel,ChanRecvstringOffset+4),2);
  write(' ');
  hexprint(ReadChanSSRam(OurChannel,ChanRecvstringOffset+5),2);
  write(' ');
  hexprint(ReadChanSSRam(OurChannel,ChanRecvstringOffset+6),2);
  write(' ');
  hexprint(ReadChanSSRam(OurChannel,ChanRecvstringOffset+7),2);
  write(' ');
  hexprint(ReadChanSSRam(OurChannel,ChanRecvstringOffset+8),2);
  write(' ');
  hexprint(ReadChanSSRam(OurChannel,ChanRecvstringOffset+9),2);
  write(' ');
  hexprint(ReadChanSSRam(OurChannel,ChanRecvstringOffset+10),2);
  write(' ');
  hexprint(ReadChanSSRam(OurChannel,ChanRecvstringOffset+11),2);
  write(' ');
  hexprint(ReadChanSSRam(OurChannel,ChanRecvstringOffset+12),2);
  write(' ');
  hexprint(ReadChanSSRam(OurChannel,ChanRecvstringOffset+13),2);
  write(' ');
  hexprint(ReadChanSSRam(OurChannel,ChanRecvstringOffset+14),2);
  write(' ');
  hexprint(ReadChanSSRam(OurChannel,ChanRecvstringOffset+15),2);
  writeln;

  ShowSSLBPState(ReadChanSSRam(OurChannel,ChanStateOffset));
  ShowSSLBPStatus(ReadChanSSRam(OurChannel,ChanStatusOffset));
  ShowSSLBPErrors('Current',ReadChanSSRam(OurChannel,ChanErrorOffset));
  ShowSSLBPErrors('Logged',ReadChanSSRam(OurChannel,ChanErrorLogOffset));

  writeln('ErrorCountLimit = ',ReadChanSSRam(OurChannel,ChanErrorCountOffset));
  writeln('CRCErrorCount = ',ReadChanSSRam(OurChannel,ChanCRCCountOffset));
  writeln('CookieErrorCount = ',ReadChanSSRam(OurChannel,ChanCookieCountOffset));
  writeln('OverrunErrorCount = ',ReadChanSSRam(OurChannel,ChanOverrunCountOffset));
  writeln('TimeOutErrorCount = ',ReadChanSSRam(OurChannel,ChanTimeOutCountOffset));
  writeln('ExtraCharErrorCount = ',ReadChanSSRam(OurChannel,ChanExtraCharCountOffset));
  writeln('BreakErrorCount = ',ReadChanSSRam(OurChannel,ChanbreakcountOffset));
{ writeln('Chktoomanyerrs = ',ReadChanSSRam(OurChannel,ChanCheckTooManyErrorsOffset)); }
  writeln('RemFaultErrorCount = ',ReadChanSSRam(OurChannel,ChanRemFaultCountOffset));
  ShowSSLBPRemoteFaults(ReadChanSSRam(OurChannel,ChanRemFaultOffset));

  write('DisableCRC = ');
  if ReadChanSSRam(OurChannel,ChanDisableCRCOffset) = 0 then writeln('False') else writeln('True');

  write('Generic = ');
  if ReadChanSSRam(OurChannel,ChanGenericOffset) = 0 then writeln('False') else writeln('True');

  write('ID = 0x');
  hexprint(ReadChanSSRam(OurChannel,ChanIDOffset),2);
  write(' WhatIAm = 0x');
  hexprint(ReadChanSSRam(OurChannel,ChanWhatIAMOffset),2);
  writeln;

  write('LBPDataSize = ',ReadChanSSRam(OurChannel,ChanLBPDataSizeOffset));

  rxchars := ReadChanSSRam(OurChannel,ChanRPCRecvSizeOffset);
  txchars := ReadChanSSRam(OurChannel,ChanRPCXmitSizeOffset);

  write(' RPCRecvSize = ',rxchars);
  writeln(' RPCXmitSize = ',txchars);

  {write('StartTime = ',ReadChanSSRam(OurChannel,ChanStartTimeOffset));}
  TimerDiv := ReadSSRamWord(TimerDivLoc);
  if TimerDiv <>0 then
  begin
    TimerTime := (TimerDiv+2)/Clock;
    write('TimerTime = ',TimerTime:3:3,' uS ');
    writeln('TimeOut = ',(ReadChanSSRam(OurChannel,ChanTimeoutOffset)*TimerTime):3:3,' uS ');
    measuredtime :=ReadChanSSRam(OurChannel,ChanMeasuredTimeOffset);
    write('MeasuredTime = ',(measuredtime*TimerTime):3:3,' uS');
    write(' Response time = ',round(measuredtime*Timertime)-((rxchars+1)*timeperchar) - ((txchars+1)*timeperchar):3:3,' uS');
    write(' LoopTime = ',(ReadSSram(LoopTimeLoc)*Timertime):3:3,' uS');
  end;
end.

